#include <iostream>
using namespace std;

#include <GL/glut.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

typedef GLdouble point2[2];

const double PI = 4*atan(1);

double starttime, lastanimtime, frametime;
double elapsedTime()
{
	return (clock() - starttime)/CLOCKS_PER_SEC;
}

point2 spiderPos;
GLdouble spiderAngle;
GLdouble walkCycleVal;
GLdouble spiderSize;
const GLdouble walkCyclesPerSecond = 2.0;
const GLdouble walkSpeed = .1; // units/second
const GLdouble turnSpeed = 30; // degrees/second

struct Food {
	point2 pos;
	GLdouble angle;
};
int numfood = 0;
Food allfood[256];

GLfloat rotamnt = 0;
void animate()
{
	frametime = elapsedTime() - lastanimtime;

	rotamnt += 30 * frametime;
	if (rotamnt > 360) rotamnt -= 360;

	lastanimtime += frametime;
	glutPostRedisplay();
}

//=============== DISPLAY FUNCTIONS =========================

void drawCircle(GLdouble X, GLdouble Y, GLdouble Radius)
{
	glBegin(GL_POLYGON);
	for (int a=0; a < 30; a++)
	{
		glVertex2f(X + Radius * (GLdouble)cos((double)a/30 * 2 * PI), 
		           Y + Radius * (GLdouble)sin((double)a/30 * 2 * PI));
	}
	glEnd();
}

void displaySpider()
{
	glPushMatrix();
	glTranslatef(spiderPos[0], spiderPos[1], 0);
	glRotatef(spiderAngle, 0, 0, 1);
	glScalef(spiderSize, spiderSize, spiderSize);

	// body
	glPushMatrix();
	glScalef(1.3,1,1);

	glColor3f(.2,.2,.8);
	drawCircle(0, 0, 1);

	glPopMatrix();

	// legs
	glColor3f(.2,.8,.8);
	for (int a = 0; a < 4; a++)
	{
		GLdouble angle = a * 22 - 33 + 90;

		glPushMatrix();
		glTranslatef( cos(angle/360*2*PI) * 1.25 * 1.3,  sin(angle/360*2*PI) * 1.25,1);
		drawCircle(0,0, 0.2);
		glPopMatrix();

		glPushMatrix();
		glTranslatef(-cos(angle/360*2*PI) * 1.25 * 1.3, -sin(angle/360*2*PI) * 1.25,1);
		drawCircle(0,0, 0.2);
		glPopMatrix();
	}

	glPopMatrix();
}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT);

	displaySpider();
	
	/*
	//glClear(GL_COLOR_BUFFER_BIT);
	glColor4f(1.0,1.0,1.0, frametime);

	glPushMatrix();
	//glTranslatef(.5, .333, 0);
	glRotatef(rotamnt, 0,0,1);
	//glTranslatef(-.5, -.333, 0);

	glBegin(GL_POINTS);
		//glVertex2f(.2,.2);
		//glVertex2f(.4,.2);
		//glVertex2f(.4,.4);
		//glVertex2f(.2,.4);

		for (int a=0; a < numpixels/10; a++)
		{
			nexttripoint = rand() % 3;

			curpoint[0] = (curpoint[0] + trianglepoints[nexttripoint][0]) / 2;
			curpoint[1] = (curpoint[1] + trianglepoints[nexttripoint][1]) / 2;

			glVertex2d(curpoint[0], curpoint[1]);
		}
	glEnd();

	glPopMatrix();
	*/

	glutSwapBuffers();
	glFlush();
}

void init(void)
{
	glClearColor(0.25, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	srand(342);

	spiderPos[0] = 0;
	spiderPos[1] = 0;
	spiderAngle = 180;//((GLdouble)(rand()) / RAND_MAX) * 360.0;
	walkCycleVal = 0;
	spiderSize = 0.3;

	starttime = clock();
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	GLdouble AspectRatio = (GLdouble)w/(GLdouble)h;
	gluOrtho2D(-1.0*AspectRatio, 1.0*AspectRatio, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(600, 400);
	glutInitWindowPosition(10, 10);
	glutCreateWindow(argv[0]);

	//for (int a = 0; a < 1000; a++)
	//	cout << rand() << endl;

	init();
	glutReshapeFunc(reshape);
	glutDisplayFunc(display);
	glutIdleFunc(animate);
	glutMainLoop();
	return 0;
}