#include <GL/glut.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

typedef GLdouble point2[2];

const point2 trianglepoints[3] = {{0,1},{-1.5/sqrt(3),-.5},{1.5/sqrt(3),-.5}};

int numpixels;

double starttime, lastanimtime, frametime;
double elapsedTime()
{
	return (clock() - starttime)/CLOCKS_PER_SEC;
}


GLfloat rotamnt = 0;
void animate()
{
	frametime = elapsedTime() - lastanimtime;

	rotamnt += 30 * frametime;
	if (rotamnt > 360) rotamnt -= 360;

	glutPostRedisplay();

	lastanimtime += frametime;
}

void display(void)
{
	point2 curpoint = {trianglepoints[0][0], trianglepoints[0][1]};
	int nexttripoint;

	//glClear(GL_COLOR_BUFFER_BIT);
	glColor4f(1.0,1.0,1.0, frametime);

	glPushMatrix();
	//glTranslatef(.5, .333, 0);
	glRotatef(rotamnt, 0,0,1);
	//glTranslatef(-.5, -.333, 0);

	glBegin(GL_POINTS);
		/*glVertex2f(.2,.2);
		glVertex2f(.4,.2);
		glVertex2f(.4,.4);
		glVertex2f(.2,.4);*/

		for (int a=0; a < numpixels/10; a++)
		{
			nexttripoint = rand() % 3;

			curpoint[0] = (curpoint[0] + trianglepoints[nexttripoint][0]) / 2;
			curpoint[1] = (curpoint[1] + trianglepoints[nexttripoint][1]) / 2;

			glVertex2d(curpoint[0], curpoint[1]);
		}
	glEnd();

	glPopMatrix();

	glutSwapBuffers();
	glFlush();
}

void init(void)
{
	glClearColor(0.25, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	starttime = clock();
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	GLdouble AspectRatio = (GLdouble)w/(GLdouble)h;
	gluOrtho2D(-1.0*AspectRatio, 1.0*AspectRatio, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);

	numpixels = w*h;
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(600, 400);
	glutInitWindowPosition(10, 10);
	glutCreateWindow(argv[0]);

	init();
	glutReshapeFunc(reshape);
	glutDisplayFunc(display);
	glutIdleFunc(animate);
	glutMainLoop();
	return 0;
}